import { Form, Row, Col, Button, FloatingLabel  } from "react-bootstrap";
import { useState } from "react";
import axios from "axios";
import { useRouter } from "next/router";
import Head from "next/head";


const OrderDetails = ({ order, currentVal, pending, closed, open }) => {
  const [status, setStatus] = useState(order.status);
  const [current, setCurrent] = useState(order.current_status);
  const [currentValue, setCurrentValue] = useState(currentVal);
  const [remarks, setRemarks] = useState('');
  const router = useRouter();

  function getOrderStatus(status, mobile) {
    if (status === "Open") {
      return <span className="open status">{mobile}</span>;
    } else if (status === "Pending") {
      return <span className="pending status">{mobile}</span>;
    }
    if (status === "Closed") {
      return <span className="closed status">{mobile}</span>;
    }
  }

  const handleStatus = (e) => {
    const status = e.target.value;
    setStatus(status);
    if (status === "Open") {
      setCurrentValue(open);
      setCurrent("New");
    } else if (status === "Pending") {
      setCurrentValue(pending);
      setCurrent("Call me Later");
    } else if (status === "Closed") {
      setCurrentValue(closed);
      setCurrent("Purchased At Poorvika");
    }
  };

  const handleCurrent = (e) => {
    const status = e.target.value;
    setCurrent(status);
  };

  const handleSubmit = async (e) => {
    e.preventDefault();
    var result = await axios.post(
      "https://ao.poorvika.com/api/update_status",
      {
        orderId: order.order_id,
        item_code:order.product_details[0].item_code,
        mobile:order.customer_details.telephone,
        remarks,
        status,
        current  
      }
    );
    if (result.data.success) {
      alert("Status Updated");
      router.push("/");
    } else alert("Not Updated");
  };

  return (
    <>
    <Head>
        <title>Poorvika - Missed Orders Details</title>
        <meta name="description" content="Generated by create next app" />
        <link rel="icon" href="/logo.png" />
      </Head>
    <div className="card row m-2">
      <div className="col-md-12 cart">
        <div className="title">
          <div className="row">
            <div className="col m-2">
              <h4>
                <b>Call Status</b>
              </h4>
            </div>
          </div>
        </div>

        <div className="row border-top border-bottom">
          <div className="row main align-items-center m-2">
            <div>
              <h4>{getOrderStatus(status, order.customer_details.telephone)} </h4>
            </div>
          </div>
          <div className="row main align-items-center m-2">
            <Form>
              <Row className="mb-3">
                <Form.Group as={Col} controlId="formGridState">
                  <Form.Label>Status</Form.Label>
                  <Form.Select value={status} onChange={(e) => handleStatus(e)}>
                    <option value="Open">Open</option>
                    <option value="Pending">Pending</option>
                    <option value="Closed">Closed</option>
                  </Form.Select>
                </Form.Group>

                <Form.Group as={Col} controlId="formGridState">
                  <Form.Label>Current Status</Form.Label>
                  <Form.Select
                    value={current}
                    onChange={(e) => handleCurrent(e)}
                  >
                    {currentValue &&
                      currentValue.map((item) => {
                        return (
                          <option key={item.val} value={item.val}>
                            {item.val}
                          </option>
                        );
                      })}
                  </Form.Select>
                </Form.Group>
                <Form.Group 
                                  style={{ marginTop: "10px" }}
                                  controlId="formGridState">
                
                  <FloatingLabel controlId="floatingTextarea2" label="Remarks">
                    <Form.Control
                      as="textarea"
                      placeholder="Leave a comment here"
                      style={{ height: '100px' }}
                      value={remarks}
                      onChange={(e) => setRemarks(e.target.value)}

                    />
                  </FloatingLabel>
                </Form.Group>
                <Form.Group
                  style={{ marginTop: "10px" }}
                  controlId="formGridState"
                >
                  <Button
                    onClick={handleSubmit}
                    variant="primary"
                    type="submit"
                  >
                    Submit
                  </Button>
                </Form.Group>
              </Row>
            </Form>
          </div>
        </div>
      </div>
    </div>
    </>
  );
};

export default OrderDetails;
